diff --git a/roms/ipxe/src/tests/aes_cbc_test.c b/roms/ipxe/src/tests/aes_cbc_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..4ae3a92e53f3774f8813e9fd8948b9705e98942d
--- /dev/null
+++ b/roms/ipxe/src/tests/aes_cbc_test.c
@@ -0,0 +1,193 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * AES-in-CBC-mode tests
+ *
+ * These test vectors are provided by NIST as part of the
+ * Cryptographic Toolkit Examples, downloadable from:
+ *
+ *    http://csrc.nist.gov/groups/ST/toolkit/documents/Examples/AES_CBC.pdf
+ *
+ */
+
+/* Forcibly enable assertions */
+#undef NDEBUG
+
+#include <assert.h>
+#include <string.h>
+#include <ipxe/aes.h>
+#include <ipxe/test.h>
+#include "cbc_test.h"
+
+/** Define inline key */
+#define KEY(...) { __VA_ARGS__ }
+
+/** Define inline initialisation vector */
+#define IV(...) { __VA_ARGS__ }
+
+/** Define inline plaintext data */
+#define PLAINTEXT(...) { __VA_ARGS__ }
+
+/** Define inline ciphertext data */
+#define CIPHERTEXT(...) { __VA_ARGS__ }
+
+/** An AES-in-CBC-mode test */
+struct aes_cbc_test {
+	/** Key */
+	const void *key;
+	/** Length of key */
+	size_t key_len;
+	/** Initialisation vector */
+	const void *iv;
+	/** Length of initialisation vector */
+	size_t iv_len;
+	/** Plaintext */
+	const void *plaintext;
+	/** Length of plaintext */
+	size_t plaintext_len;
+	/** Ciphertext */
+	const void *ciphertext;
+	/** Length of ciphertext */
+	size_t ciphertext_len;
+};
+
+/**
+ * Define an AES-in-CBC-mode test
+ *
+ * @v name		Test name
+ * @v key_array		Key
+ * @v iv_array		Initialisation vector
+ * @v plaintext_array	Plaintext
+ * @v ciphertext_array	Ciphertext
+ * @ret test		AES-in-CBC-mode test
+ */
+#define AES_CBC_TEST( name, key_array, iv_array, plaintext_array,	\
+		      ciphertext_array )				\
+	static const uint8_t name ## _key [] = key_array;		\
+	static const uint8_t name ## _iv [] = iv_array;			\
+	static const uint8_t name ## _plaintext [] = plaintext_array;	\
+	static const uint8_t name ## _ciphertext [] = ciphertext_array;	\
+	static struct aes_cbc_test name = {				\
+		.key = name ## _key,					\
+		.key_len = sizeof ( name ## _key ),			\
+		.iv = name ## _iv,					\
+		.iv_len = sizeof ( name ## _iv ),			\
+		.plaintext = name ## _plaintext,			\
+		.plaintext_len = sizeof ( name ## _plaintext ),		\
+		.ciphertext = name ## _ciphertext,			\
+		.ciphertext_len = sizeof ( name ## _ciphertext ),	\
+	}
+
+/**
+ * Report AES-in-CBC-mode
+ *
+ * @v state		HMAC_DRBG internal state
+ * @v test		Instantiation test
+ */
+#define aes_cbc_ok( test ) do {						\
+	struct cipher_algorithm *cipher = &aes_cbc_algorithm;		\
+									\
+	assert ( (test)->iv_len == cipher->blocksize );			\
+	assert ( (test)->plaintext_len == (test)->ciphertext_len );	\
+	cbc_encrypt_ok ( cipher, (test)->key, (test)->key_len,		\
+			 (test)->iv, (test)->plaintext,			\
+			 (test)->ciphertext, (test)->plaintext_len );	\
+	cbc_decrypt_ok ( cipher, (test)->key, (test)->key_len,		\
+			 (test)->iv, (test)->ciphertext,		\
+			 (test)->plaintext, (test)->ciphertext_len );	\
+	} while ( 0 )
+
+/** CBC_AES128 */
+AES_CBC_TEST ( test_128,
+	KEY ( 0x2b, 0x7e, 0x15, 0x16, 0x28, 0xae, 0xd2, 0xa6, 0xab, 0xf7, 0x15,
+	      0x88, 0x09, 0xcf, 0x4f, 0x3c ),
+	IV ( 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a,
+	     0x0b, 0x0c, 0x0d, 0x0e, 0x0f ),
+	PLAINTEXT ( 0x6b, 0xc1, 0xbe, 0xe2, 0x2e, 0x40, 0x9f, 0x96,
+		    0xe9, 0x3d, 0x7e, 0x11, 0x73, 0x93, 0x17, 0x2a,
+		    0xae, 0x2d, 0x8a, 0x57, 0x1e, 0x03, 0xac, 0x9c,
+		    0x9e, 0xb7, 0x6f, 0xac, 0x45, 0xaf, 0x8e, 0x51,
+		    0x30, 0xc8, 0x1c, 0x46, 0xa3, 0x5c, 0xe4, 0x11,
+		    0xe5, 0xfb, 0xc1, 0x19, 0x1a, 0x0a, 0x52, 0xef,
+		    0xf6, 0x9f, 0x24, 0x45, 0xdf, 0x4f, 0x9b, 0x17,
+		    0xad, 0x2b, 0x41, 0x7b, 0xe6, 0x6c, 0x37, 0x10 ),
+	CIPHERTEXT ( 0x76, 0x49, 0xab, 0xac, 0x81, 0x19, 0xb2, 0x46,
+		     0xce, 0xe9, 0x8e, 0x9b, 0x12, 0xe9, 0x19, 0x7d,
+		     0x50, 0x86, 0xcb, 0x9b, 0x50, 0x72, 0x19, 0xee,
+		     0x95, 0xdb, 0x11, 0x3a, 0x91, 0x76, 0x78, 0xb2,
+		     0x73, 0xbe, 0xd6, 0xb8, 0xe3, 0xc1, 0x74, 0x3b,
+		     0x71, 0x16, 0xe6, 0x9e, 0x22, 0x22, 0x95, 0x16,
+		     0x3f, 0xf1, 0xca, 0xa1, 0x68, 0x1f, 0xac, 0x09,
+		     0x12, 0x0e, 0xca, 0x30, 0x75, 0x86, 0xe1, 0xa7 ) );
+
+/** CBC_AES256 */
+AES_CBC_TEST ( test_256,
+	KEY ( 0x60, 0x3d, 0xeb, 0x10, 0x15, 0xca, 0x71, 0xbe, 0x2b, 0x73, 0xae,
+	      0xf0, 0x85, 0x7d, 0x77, 0x81, 0x1f, 0x35, 0x2c, 0x07, 0x3b, 0x61,
+	      0x08, 0xd7, 0x2d, 0x98, 0x10, 0xa3, 0x09, 0x14, 0xdf, 0xf4 ),
+	IV ( 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a,
+	     0x0b, 0x0c, 0x0d, 0x0e, 0x0f ),
+	PLAINTEXT ( 0x6b, 0xc1, 0xbe, 0xe2, 0x2e, 0x40, 0x9f, 0x96,
+		    0xe9, 0x3d, 0x7e, 0x11, 0x73, 0x93, 0x17, 0x2a,
+		    0xae, 0x2d, 0x8a, 0x57, 0x1e, 0x03, 0xac, 0x9c,
+		    0x9e, 0xb7, 0x6f, 0xac, 0x45, 0xaf, 0x8e, 0x51,
+		    0x30, 0xc8, 0x1c, 0x46, 0xa3, 0x5c, 0xe4, 0x11,
+		    0xe5, 0xfb, 0xc1, 0x19, 0x1a, 0x0a, 0x52, 0xef,
+		    0xf6, 0x9f, 0x24, 0x45, 0xdf, 0x4f, 0x9b, 0x17,
+		    0xad, 0x2b, 0x41, 0x7b, 0xe6, 0x6c, 0x37, 0x10 ),
+	CIPHERTEXT ( 0xf5, 0x8c, 0x4c, 0x04, 0xd6, 0xe5, 0xf1, 0xba,
+		     0x77, 0x9e, 0xab, 0xfb, 0x5f, 0x7b, 0xfb, 0xd6,
+		     0x9c, 0xfc, 0x4e, 0x96, 0x7e, 0xdb, 0x80, 0x8d,
+		     0x67, 0x9f, 0x77, 0x7b, 0xc6, 0x70, 0x2c, 0x7d,
+		     0x39, 0xf2, 0x33, 0x69, 0xa9, 0xd9, 0xba, 0xcf,
+		     0xa5, 0x30, 0xe2, 0x63, 0x04, 0x23, 0x14, 0x61,
+		     0xb2, 0xeb, 0x05, 0xe2, 0xc3, 0x9b, 0xe9, 0xfc,
+		     0xda, 0x6c, 0x19, 0x07, 0x8c, 0x6a, 0x9d, 0x1b ) );
+
+/**
+ * Perform AES-in-CBC-mode self-test
+ *
+ */
+static void aes_cbc_test_exec ( void ) {
+	struct cipher_algorithm *cipher = &aes_cbc_algorithm;
+
+	/* Correctness tests */
+	aes_cbc_ok ( &test_128 );
+	aes_cbc_ok ( &test_256 );
+
+	/* Speed tests */
+	DBG ( "AES128 encryption required %ld cycles per byte\n",
+	      cbc_cost_encrypt ( cipher, test_128.key_len ) );
+	DBG ( "AES128 decryption required %ld cycles per byte\n",
+	      cbc_cost_decrypt ( cipher, test_128.key_len ) );
+	DBG ( "AES256 encryption required %ld cycles per byte\n",
+	      cbc_cost_encrypt ( cipher, test_256.key_len ) );
+	DBG ( "AES256 decryption required %ld cycles per byte\n",
+	      cbc_cost_decrypt ( cipher, test_256.key_len ) );
+}
+
+/** AES-in-CBC-mode self-test */
+struct self_test aes_cbc_test __self_test = {
+	.name = "aes_cbc",
+	.exec = aes_cbc_test_exec,
+};
diff --git a/roms/ipxe/src/tests/base64_test.c b/roms/ipxe/src/tests/base64_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..c088298ca62f40729ab6c361cc729f5ca76fd4bb
--- /dev/null
+++ b/roms/ipxe/src/tests/base64_test.c
@@ -0,0 +1,124 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Base64 tests
+ *
+ * Test vectors generated using "base64 -w 0"
+ *
+ */
+
+/* Forcibly enable assertions */
+#undef NDEBUG
+
+#include <stdint.h>
+#include <string.h>
+#include <ipxe/base64.h>
+#include <ipxe/test.h>
+
+/** A Base64 test */
+struct base64_test {
+	/** Raw data */
+	const void *data;
+	/** Length of raw data */
+	size_t len;
+	/** Base64-encoded data */
+	const char *encoded;
+};
+
+/** Define inline data */
+#define DATA(...) { __VA_ARGS__ }
+
+/** Define a base64 test */
+#define BASE64( name, DATA, ENCODED )					\
+	static const uint8_t name ## _data[] = DATA;			\
+	static struct base64_test name = {				\
+		.data = name ## _data,					\
+		.len = sizeof ( name ## _data ),			\
+		.encoded = ENCODED,					\
+	}
+
+/** Empty data test */
+BASE64 ( empty_test, DATA(), "" );
+
+/** "Hello world" test */
+BASE64 ( hw_test,
+	 DATA ( 'H', 'e', 'l', 'l', 'o', ' ', 'w', 'o', 'r', 'l', 'd' ),
+	 "SGVsbG8gd29ybGQ=" );
+
+/** Random data test */
+BASE64 ( random_test,
+	 DATA ( 0x36, 0x03, 0x84, 0xdc, 0x4e, 0x03, 0x46, 0xa0, 0xb5, 0x2d,
+		0x03, 0x6e, 0xd0, 0x56, 0xed, 0xa0, 0x37, 0x02, 0xac, 0xc6,
+		0x65, 0xd1 ),
+	 "NgOE3E4DRqC1LQNu0FbtoDcCrMZl0Q==" );
+
+/**
+ * Report a base64 encoding test result
+ *
+ * @v test		Base64 test
+ */
+#define base64_encode_ok( test ) do {					\
+	size_t len = base64_encoded_len ( (test)->len );		\
+	char buf[ len + 1 /* NUL */ ];					\
+	ok ( len == strlen ( (test)->encoded ) );			\
+	base64_encode ( (test)->data, (test)->len, buf );		\
+	ok ( strcmp ( (test)->encoded, buf ) == 0 );			\
+	} while ( 0 )
+
+/**
+ * Report a base64 decoding test result
+ *
+ * @v test		Base64 test
+ */
+#define base64_decode_ok( test ) do {					\
+	size_t max_len = base64_decoded_max_len ( (test)->encoded );	\
+	uint8_t buf[max_len];						\
+	int len;							\
+	len = base64_decode ( (test)->encoded, buf );			\
+	ok ( len >= 0 );						\
+	ok ( ( size_t ) len <= max_len );				\
+	ok ( ( size_t ) len == (test)->len );				\
+	ok ( memcmp ( (test)->data, buf, len ) == 0 );			\
+	} while ( 0 )
+
+/**
+ * Perform Base64 self-tests
+ *
+ */
+static void base64_test_exec ( void ) {
+
+	base64_encode_ok ( &empty_test );
+	base64_decode_ok ( &empty_test );
+
+	base64_encode_ok ( &hw_test );
+	base64_decode_ok ( &hw_test );
+
+	base64_encode_ok ( &random_test );
+	base64_decode_ok ( &random_test );
+}
+
+/** Base64 self-test */
+struct self_test base64_test __self_test = {
+	.name = "base64",
+	.exec = base64_test_exec,
+};
diff --git a/roms/ipxe/src/tests/bofm_test.c b/roms/ipxe/src/tests/bofm_test.c
index 6f2e6c6739d7a40402b60ae1a180..e430d12d49fb3d5f83dbfa72f3d1 100644
--- a/roms/ipxe/src/tests/bofm_test.c
+++ b/roms/ipxe/src/tests/bofm_test.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/tests/byteswap_test.c b/roms/ipxe/src/tests/byteswap_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..a500218be67304ec882eed3bd6712d3409fea14d
--- /dev/null
+++ b/roms/ipxe/src/tests/byteswap_test.c
@@ -0,0 +1,92 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * Byte-order swapping test functions
+ *
+ */
+
+/* Forcibly enable assertions */
+#undef NDEBUG
+
+#include <stdint.h>
+#include <assert.h>
+#include <byteswap.h>
+#include <ipxe/test.h>
+
+/* Provide global functions to allow inspection of generated assembly code */
+
+uint16_t test_bswap16 ( uint16_t x ) {
+	return __bswap_16 ( x );
+}
+
+uint32_t test_bswap32 ( uint32_t x ) {
+	return __bswap_32 ( x );
+}
+
+uint64_t test_bswap64 ( uint64_t x ) {
+	return __bswap_64 ( x );
+}
+
+void test_bswap16s ( uint16_t *x ) {
+	__bswap_16s ( x );
+}
+
+void test_bswap32s ( uint32_t *x ) {
+	__bswap_32s ( x );
+}
+
+void test_bswap64s ( uint64_t *x ) {
+	__bswap_64s ( x );
+}
+
+/**
+ * Perform byte-order swapping
+ *
+ */
+static void byteswap_test_exec ( void ) {
+	uint16_t test16;
+	uint32_t test32;
+	uint64_t test64;
+
+	ok ( test_bswap16 ( 0x1234 ) == 0x3412 );
+	ok ( test_bswap32 ( 0x12345678UL ) == 0x78563412UL );
+	ok ( test_bswap64 ( 0x123456789abcdef0ULL ) == 0xf0debc9a78563412ULL );
+
+	test16 = 0xabcd;
+	test_bswap16s ( &test16 );
+	ok ( test16 == 0xcdab );
+
+	test32 = 0xabcdef01UL;
+	test_bswap32s ( &test32 );
+	ok ( test32 == 0x01efcdabUL );
+
+	test64 = 0xabcdef0123456789ULL;
+	test_bswap64s ( &test64 );
+	ok ( test64 == 0x8967452301efcdabULL );
+}
+
+/** Byte-order swapping self-test */
+struct self_test byteswap_test __self_test = {
+	.name = "byteswap",
+	.exec = byteswap_test_exec,
+};
diff --git a/roms/ipxe/src/tests/cbc_test.c b/roms/ipxe/src/tests/cbc_test.c
new file mode 100644
index 0000000000000000000000000000000000000000..ada991b219b55fde09ac89ec32522054e57738c3
--- /dev/null
+++ b/roms/ipxe/src/tests/cbc_test.c
@@ -0,0 +1,171 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * CBC self-tests
+ *
+ */
+
+/* Forcibly enable assertions */
+#undef NDEBUG
+
+#include <stdint.h>
+#include <stdlib.h>
+#include <string.h>
+#include <assert.h>
+#include <ipxe/crypto.h>
+#include <ipxe/profile.h>
+#include "cbc_test.h"
+
+/**
+ * Test CBC encryption
+ *
+ * @v cipher			Cipher algorithm
+ * @v key			Key
+ * @v key_len			Length of key
+ * @v iv			Initialisation vector
+ * @v plaintext			Plaintext data
+ * @v expected_ciphertext	Expected ciphertext data
+ * @v len			Length of data
+ * @ret ok			Ciphertext is as expected
+ */
+int cbc_test_encrypt ( struct cipher_algorithm *cipher, const void *key,
+		       size_t key_len, const void *iv, const void *plaintext,
+		       const void *expected_ciphertext, size_t len ) {
+	uint8_t ctx[cipher->ctxsize];
+	uint8_t ciphertext[len];
+	int rc;
+
+	/* Initialise cipher */
+	rc = cipher_setkey ( cipher, ctx, key, key_len );
+	assert ( rc == 0 );
+	cipher_setiv ( cipher, ctx, iv );
+
+	/* Perform encryption */
+	cipher_encrypt ( cipher, ctx, plaintext, ciphertext, len );
+
+	/* Verify result */
+	return ( memcmp ( ciphertext, expected_ciphertext, len ) == 0 );
+}
+
+/**
+ * Test CBC decryption
+ *
+ * @v cipher			Cipher algorithm
+ * @v key			Key
+ * @v key_len			Length of key
+ * @v iv			Initialisation vector
+ * @v ciphertext		Ciphertext data
+ * @v expected_plaintext	Expected plaintext data
+ * @v len			Length of data
+ * @ret ok			Plaintext is as expected
+ */
+int cbc_test_decrypt ( struct cipher_algorithm *cipher, const void *key,
+		       size_t key_len, const void *iv, const void *ciphertext,
+		       const void *expected_plaintext, size_t len ) {
+	uint8_t ctx[cipher->ctxsize];
+	uint8_t plaintext[len];
+	int rc;
+
+	/* Initialise cipher */
+	rc = cipher_setkey ( cipher, ctx, key, key_len );
+	assert ( rc == 0 );
+	cipher_setiv ( cipher, ctx, iv );
+
+	/* Perform encryption */
+	cipher_decrypt ( cipher, ctx, ciphertext, plaintext, len );
+
+	/* Verify result */
+	return ( memcmp ( plaintext, expected_plaintext, len ) == 0 );
+}
+
+/**
+ * Calculate CBC encryption or decryption cost
+ *
+ * @v cipher			Cipher algorithm
+ * @v key_len			Length of key
+ * @v op			Encryption or decryption operation
+ * @ret cost			Cost (in cycles per byte)
+ */
+static unsigned long cbc_cost ( struct cipher_algorithm *cipher,
+				size_t key_len,
+				void ( * op ) ( struct cipher_algorithm *cipher,
+						void *ctx, const void *src,
+						void *dst, size_t len ) ) {
+	static uint8_t random[8192]; /* Too large for stack */
+	uint8_t key[key_len];
+	uint8_t iv[cipher->blocksize];
+	uint8_t ctx[cipher->ctxsize];
+	union profiler profiler;
+	unsigned long long elapsed;
+	unsigned long cost;
+	unsigned int i;
+	int rc;
+
+	/* Fill buffer with pseudo-random data */
+	srand ( 0x1234568 );
+	for ( i = 0 ; i < sizeof ( random ) ; i++ )
+		random[i] = rand();
+	for ( i = 0 ; i < sizeof ( key ) ; i++ )
+		key[i] = rand();
+	for ( i = 0 ; i < sizeof ( iv ) ; i++ )
+		iv[i] = rand();
+
+	/* Initialise cipher */
+	rc = cipher_setkey ( cipher, ctx, key, key_len );
+	assert ( rc == 0 );
+	cipher_setiv ( cipher, ctx, iv );
+
+	/* Time operation */
+	profile ( &profiler );
+	op ( cipher, ctx, random, random, sizeof ( random ) );
+	elapsed = profile ( &profiler );
+
+	/* Round to nearest whole number of cycles per byte */
+	cost = ( ( elapsed + ( sizeof ( random ) / 2 ) ) / sizeof ( random ) );
+
+	return cost;
+}
+
+/**
+ * Calculate CBC encryption cost
+ *
+ * @v cipher			Cipher algorithm
+ * @v key_len			Length of key
+ * @ret cost			Cost (in cycles per byte)
+ */
+unsigned long cbc_cost_encrypt ( struct cipher_algorithm *cipher,
+				 size_t key_len ) {
+	return cbc_cost ( cipher, key_len, cipher_encrypt );
+}
+
+/**
+ * Calculate CBC decryption cost
+ *
+ * @v cipher			Cipher algorithm
+ * @v key_len			Length of key
+ * @ret cost			Cost (in cycles per byte)
+ */
+unsigned long cbc_cost_decrypt ( struct cipher_algorithm *cipher,
+				 size_t key_len ) {
+	return cbc_cost ( cipher, key_len, cipher_decrypt );
+}
diff --git a/roms/ipxe/src/tests/cbc_test.h b/roms/ipxe/src/tests/cbc_test.h
new file mode 100644
index 0000000000000000000000000000000000000000..ad9e6f341fad1516e1d5f75807c580f66f5381a7
--- /dev/null
+++ b/roms/ipxe/src/tests/cbc_test.h
@@ -0,0 +1,57 @@
+#ifndef _CBC_TEST_H
+#define _CBC_TEST_H
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <stdint.h>
+#include <ipxe/crypto.h>
+#include <ipxe/test.h>
+
+extern int cbc_test_encrypt ( struct cipher_algorithm *cipher, const void *key,
+			      size_t key_len, const void *iv,
+			      const void *plaintext,
+			      const void *expected_ciphertext, size_t len );
+extern int cbc_test_decrypt ( struct cipher_algorithm *cipher, const void *key,
+			      size_t key_len, const void *iv,
+			      const void *ciphertext,
+			      const void *expected_plaintext, size_t len );
+extern unsigned long cbc_cost_encrypt ( struct cipher_algorithm *cipher,
+					size_t key_len );
+extern unsigned long cbc_cost_decrypt ( struct cipher_algorithm *cipher,
+					size_t key_len );
+
+/**
+ * Report CBC encryption test result
+ *
+ * @v cipher			Cipher algorithm
+ * @v key			Key
+ * @v key_len			Length of key
+ * @v iv			Initialisation vector
+ * @v plaintext			Plaintext data
+ * @v expected_ciphertext	Expected ciphertext data
+ * @v len			Length of data
+ */
+#define cbc_encrypt_ok( cipher, key, key_len, iv, plaintext,		\
+			expected_ciphertext, len ) do {			\
+	ok ( cbc_test_encrypt ( cipher, key, key_len, iv, plaintext,	\
+				expected_ciphertext, len ) );		\
+	} while ( 0 )
+
+/**
+ * Report CBC decryption test result
+ *
+ * @v cipher			Cipher algorithm
+ * @v key			Key
+ * @v key_len			Length of key
+ * @v iv			Initialisation vector
+ * @v ciphertext		Ciphertext data
+ * @v expected_plaintext	Expected plaintext data
+ * @v len			Length of data
+ */
+#define cbc_decrypt_ok( cipher, key, key_len, iv, ciphertext,		\
+			expected_plaintext, len ) do {			\
+	ok ( cbc_test_decrypt ( cipher, key, key_len, iv, ciphertext,	\
+				expected_plaintext, len ) );		\
+	} while ( 0 )
+
+#endif /* _CBC_TEST_H */
